import * as ts from 'typescript';
export declare class Collection<T extends ts.Node, R extends ts.Node> {
    private _root;
    protected collected: T[];
    static fromSource(source: string): Collection<ts.SourceFile, ts.SourceFile>;
    static fromNode<T extends ts.Node>(node: T): Collection<T, T>;
    private constructor(collected, root?);
    private readonly root;
    protected rootNode: R;
    find(kind: ts.SyntaxKind.Identifier, pattern?: IdentifierPattern): Collection<ts.Identifier, R>;
    find(kind: ts.SyntaxKind.FunctionDeclaration): Collection<ts.FunctionDeclaration, R>;
    find(kind: ts.SyntaxKind.FunctionExpression): Collection<ts.FunctionExpression, R>;
    find(kind: ts.SyntaxKind.CallExpression, pattern?: CallExpressionPattern): Collection<ts.CallExpression, R>;
    find(kind: ts.SyntaxKind.VariableDeclarationList): Collection<ts.VariableDeclarationList, R>;
    find(kind: ts.SyntaxKind.VariableDeclaration): Collection<ts.VariableDeclaration, R>;
    find(kind: ts.SyntaxKind.TypeReference, pattern?: any): Collection<ts.TypeReferenceNode, R>;
    get<U extends ts.Node>(fn: (node: T) => U | undefined): Collection<U, R>;
    filter(fn: (node: T) => boolean): Collection<T, R>;
    replaceWith(fn: (node: T) => ts.Node): this;
    forEach(fn: (node: T) => void): this;
    size(): number;
    toSource(): string;
}
export interface IdentifierPattern {
    text: string;
}
export interface CallExpressionPattern {
    expression: any;
}
