"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const collection_1 = require("./collection");
const api = {
    tscodeshift: (source) => {
        if (typeof source === 'string') {
            return collection_1.Collection.fromSource(source);
        }
        else {
            return collection_1.Collection.fromNode(source);
        }
    }
};
/* @internal */
function applyTransforms(path, source, transforms) {
    const file = {
        path,
        source
    };
    return transforms
        .reduce((file, transform) => {
        return {
            path: file.path,
            source: transform(file, api)
        };
    }, file)
        .source;
}
exports.applyTransforms = applyTransforms;
