"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_tags_1 = require("common-tags");
const transform_1 = require("../transform");
const jest_1 = require("./jest");
test('Convert mocha test to jest test', () => {
    const source = common_tags_1.stripIndent `
    before(() => {
      // something
    });

    beforeEach(() => {
    });

    suite('Array', function() {
      setup(() => {
      });

      test('Array', (done: MochaDone) => {
        done();
      });

      specify.skip('Array', function(done) {
        done();
      });
    });

    describe('', () => {
      it('', (done: MochaDone) => {
      });
    });
  `;
    const expected = common_tags_1.stripIndent `
    beforeAll(()=> {
      // something
    });

    beforeEach(()=> {
    });

    describe('Array', function() {
      beforeEach(()=> {
      });

      it('Array', (done: jest.DoneCallback) => {
        done();
      });

      it.skip('Array', function(done) {
        done();
      });
    });

    describe('', () => {
      it('', (done: jest.DoneCallback) => {
      });
    });
  `;
    const actual = transform_1.applyTransforms('path.ts', source, [jest_1.default]);
    expect(actual).toBe(expected);
});
